<?php
/*

 Info for WordPress:
 ==============================================================================
 Plugin Name: podPress
 Version: 3.0
 Plugin URI: http://www.mightyseek.com/podpress/
 Description: The podPress pluggin gives you everything you need in one easy plugin to use WordPress for Podcasting. Set it up in <a href="options-general.php?page=podpress.php">'Options'-> podPress</a>. If you this plugin works for you, send us a comment</a>.
 Author: Dan Kuykendall (Seek3r)
 Author URI: http://www.mightyseek.com/


 podPress - Podcasting made easy for WordPress
 ==============================================================================
 
 This plugin makes it much easier and organized to use WordPress for Podcasting.

 The plugin was created as a way for me to merge Garrick Van Buren's  WP-iPodCatter 
 and Martin Laine's Audio Player with some hacks I made to Word Press 2.0. 
 I had tweaked the player to have the [audio:filename.mp3] entry to drive the 
 whole podcasting need. In the rss2.php I had tweaked it to generate the 
 enclosure tag from it. So thats how the plugin took birth, and I have been adding
 features to make the process cleaner over time.
 
 Feel free to visit my website under www.mightyseek.com or contact me at
 dan [at] kuykendall [dot] org
 
 Have fun!    
   
 Installation:
 ==============================================================================
 1. Upload the full directory into your wp-content/plugins directory
 2. Replace wp-rss2.php and 
 2. Activate it in the Plugin options
 3. Edit or publish a post or click on Rebuild Sitemap on the Sitemap Administration Interface

 
 Contributors:
 ==============================================================================
 Developer              Dan Kuykendall      http://www.mightyseek.com/

 Audio player           Martin Laine        http://www.1pixelout.net
 WP-iPodCatter          Garrick Van Buren   http://garrickvanburen.com/
 
 Thanks to all contributors and bug reporters! :)
 
 
 Release History:
 ==============================================================================
 Instead of maintaining the history in here, Im just going to maintain it at
 http://www.mightyseek.com/podpress/changelog/
 
 Todo:
 ==============================================================================
 - Add easy upload functionality
 - Get a better handle on what comment-casting is all about.

 License:
 ==============================================================================

    Copyright 2006  Dan Kuykendall  (email : dan@kuykendall.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

if(!class_exists ('podpress_plugin')){
	load_plugin_textdomain('podpress','wp-content/plugins/podpress');	
	class podpress_plugin {
		var $version = '3.0';
		var $playerOptions = array();
		var $settings = array();
		var $podcastTag_regexp = "/\[podcast:([^]]+)]/";
		var $podcastTag = '[display_podcast]';

		/*************************************************************/
		/* Load up the plugin values and get ready to action         */
		/*************************************************************/
		function test() {
			echo 'BLAHBLAHBLAH';
		}
		function podpress_plugin() {
			/* Check for / Initialize basic settings, or upgrades needed */			
			$this->init(get_option('podPress_version'));

			$this->settings['audioWebPath'] = get_option('podPress_audioWebPath');			
			$this->settings['audioFilePath'] = get_option('podPress_audioFilePath');
					
			if(empty($this->settings['audioFilePath']) || $this->settings['audioFilePath'] == '' || !file_exists($this->settings['audioFilePath'])) {
				$this->settings['autoDetectedaudioFilePath'] = substr(str_replace('wp-admin', '', getcwd()), 0, -1).$this->settings['audioWebPath']	;

				if(!file_exists($this->settings['autoDetectedaudioFilePath'])) {
					$this->settings['autoDetectedaudioFilePath'] = 'Auto Detection Failed.';
				}
			}
			
			$this->settings['beforeMore'] = get_option("podPress_BeforeMore");
			
			$this->settings['playerURL'] = get_settings('siteurl') . '/wp-content/plugins/podpress/player.swf';

			$this->playerOptions['bg'] = get_option("podPress_player_bgcolor");
			$this->playerOptions['leftbg'] = get_option("podPress_player_leftbgcolor");
			$this->playerOptions['lefticon'] = get_option("podPress_player_lefticoncolor");
			$this->playerOptions['rightbg'] = get_option("podPress_player_rightbgcolor");
			$this->playerOptions['rightbghover'] = get_option("podPress_player_rightbghovercolor");
			$this->playerOptions['righticon'] = get_option("podPress_player_righticoncolor");
			$this->playerOptions['righticonhover'] = get_option("podPress_player_righticonhovercolor");
			$this->playerOptions['text'] = get_option("podPress_player_textcolor");
			$this->playerOptions['slider'] = get_option("podPress_player_slidercolor");
			$this->playerOptions['track'] = get_option("podPress_player_trackcolor");
			$this->playerOptions['border'] = get_option("podPress_player_bordercolor");
			$this->playerOptions['loader'] = get_option("podPress_player_loadercolor");

			$this->settings['itunesFeedURL'] = get_option('itunesFeedURL');
			if(empty($this->settings['itunesFeedURL'])) {
				$this->settings['itunesFeedURL'] = get_settings('siteurl').'/&feed=rss2';
			}
			$this->settings['itunesFeedID'] = get_option('itunesFeedID');
			$this->settings['itunesAdminName'] = get_option('itunesAdminName');
			$this->settings['itunesAdminEmail']  = get_option('itunesAdminEmail');
			$this->settings['itunesTTL']  = get_option('itunesTTL');
			$this->settings['blogdescription'] = get_option('blogdescription');			
			$this->settings['podcastdescription'] = get_option('podcastdescription');

			if(!$this->settings['podcastdescription'] || empty($this->settings['podcastdescription']))  { update_option('podcastdescription', $this->settings['blogdescription']); }

			$this->settings['itunesSubtitle'] = get_option('itunesSubtitle');
			$this->settings['itunesDefaultExplicit']  = get_option('itunesDefaultExplicit');
			$this->settings['itunesCategory1'] = get_option('itunesCategory1');
			$this->settings['itunesCategory2'] = get_option('itunesCategory2');
			$this->settings['itunesCategory3'] = get_option('itunesCategory3');

	
			$this->settings['itunesUseKeyword']  = get_option('itunesUseKeyword');
			$this->settings['itunesFeedKeywords']  = get_option('itunesFeedKeywords');
			
			$this->settings['itunesImageBig']  = get_option('itunesImageBig');
			$this->settings['itunesImageSmall']  = get_option('itunesImageSmall'); 

			$this->settings['defaultFeedFormat']  = get_option('podPress_defaultFeedFormat'); 

			$this->settings['channelCat']  = get_option('channelCat'); 

			if($this->settings['itunesCommentCast'] == "yes") {
				$this->settings['itunesCommentCast'] = 'checked="checked"';
			}
		}

		/*************************************************************/
		/* Handle all the default values for a new install of plugin */
		/*************************************************************/
		function init($current = true) {
			GLOBAL $wpdb;
			if(!$current)
			{
				if(function_exists('wp_cache_flush'))
				{
					wp_cache_flush();
				}
				add_option('podPress_version', $this->version);
				if(get_option('podPress_audioWebPath') == '')
				{
					add_option('podPress_audioWebPath', '/audio', "Web path to Podcast audio files", true);
				}

				add_option('itunesImageBig', get_settings('siteurl').'/wp-content/plugins/podpress/powered_by_podpress_large.jpg', true);
				add_option('itunesImageSmall', get_settings('siteurl').'/wp-content/plugins/podpress/powered_by_podpress.jpg', true);

				add_option('podPress_BeforeMore', 'yes', 'Before the <!--more--> tag', true);
					
				if(get_option('podPress_player_bgcolor') == '')	{
					add_option('podPress_player_bgcolor', '0xf8f8f8', "Background color", true);
					add_option('podPress_player_textcolor', '0x666666', "Text color", true);
					add_option('podPress_player_leftbgcolor', '0xeeeeee', "Left background color", true);
					add_option('podPress_player_lefticoncolor', '0x666666', "Left icon color", true);
					add_option('podPress_player_rightbgcolor', '0xcccccc', "Right background color", true);
					add_option('podPress_player_rightbghovercolor', '0x999999', "Right background hover color", true);
					add_option('podPress_player_righticoncolor', '0x666666', "Right icon color", true);
					add_option('podPress_player_righticonhovercolor', '0xffffff', "Right icon hover color", true);
					add_option('podPress_player_slidercolor', '0x666666', "Progress slider color", true);
					add_option('podPress_player_trackcolor', '0xFFFFFF', "Progress track color", true);
					add_option('podPress_player_loadercolor', '0x9FFFB8', "Loader bar color", true);
					add_option('podPress_player_bordercolor', '0x666666', "Border color", true);
				}
				return;
			}

			if('1.5' >= $current)
			{
				$posts_that_need_upgrades = array();
				$posts = $wpdb->get_results("SELECT ID, post_content FROM ".$wpdb->posts);
				if($posts) {
					foreach ($posts as $post) {
						$podcastTagFileName = $this->getPodcastTagValue($post->post_content);
						if($podcastTagFileName){
							$posts_that_need_upgrades[$post->ID] = $post->post_content;
						}
					}
					
					reset($posts_that_need_upgrades);
					foreach($posts_that_need_upgrades as $key => $value){
						$wpdb->query("UPDATE ".$wpdb->posts." SET post_content = '".preg_replace($this->podcastTag_regexp, '', $value)."' WHERE ID=".$key);
						$podcastTagFileName = $this->getPodcastTagValue($content);
						delete_post_meta($key, 'podPress_podcastStandardAudio');
						add_post_meta($key, 'podPress_podcastStandardAudio', $podcastTagFileName, true);
					}
				}
				if(function_exists('wp_cache_flush'))
				{
					wp_cache_flush();
				}
				$current = '2.0';
				update_option('podPress_version', $current);
			}
			if('2.0' > $current) //placeholder
			{
				$current = '2.1';
				update_option('podPress_version', $current);
			}
			if('2.1' > $current) //placeholder
			{
				$current = '2.2';
				update_option('podPress_version', $current);
			}
			if('2.2' > $current) //placeholder
			{
				$current = '2.3';
				update_option('podPress_version', $current);
			}
			if('2.3' > $current) //placeholder
			{
				$current = '2.4';
				update_option('podPress_version', $current);
			}
			if('2.4' > $current) //placeholder
			{
				$current = '2.5';
				update_option('podPress_version', $current);
			}
			if('2.5' > $current) //placeholder
			{
				$current = '3.0';
				update_option('podPress_version', $current);
			}
		}
		
		function get($varname = '##NOTSET##')
		{
			if(isset($this->settings[$varname])) {
				return $this->settings[$varname];
			}
			return false;
		}

		function iTunesLink() {
			return '<a href="http://phobos.apple.com/WebObjects/MZStore.woa/wa/viewPodcast?id='.$this->settings['itunesFeedID'].'"><img src="'.get_settings('siteurl').'/wp-content/plugins/podpress/itunes.gif" border="0" alt="View in iTunes"/></a>';
		}
		
		function loadID3() {
			if(!defined('GETID3_VERSION')){
				if(file_exists('podpress/getid3/getid3.php')) {
					$file = 'podpress/getid3/getid3.php';
				} elseif(file_exists('getid3/getid3.php')) {
					$file = 'getid3/getid3.php';
				} else {
					return false;
				}
				if(!include_once($file))
				{
					return false;
				}
			}
			return new getID3; 
		}
		
		function convertPodcastFileNameToWebPath($filename = ''){
			GLOBAL $podPress;

			if(preg_match('/^(http|https):/i' ,$filename)) {
				return $filename;
			}

			if(preg_match('/^(http|https):/i' ,$podPress->settings['audioWebPath'])) {
				$baseurl = $podPress->settings['audioWebPath'];
			} elseif(substr($filename, 0,1) == '/') {
				$baseurl = strtolower(strtok($_SERVER['SERVER_PROTOCOL'], '/')).'://'.$_SERVER['HTTP_HOST'].$podPress->settings['audioWebPath'];
			} else {
				$baseurl = get_settings('siteurl').$podPress->settings['audioWebPath'];
			}
				
			if(substr($filename, -1, 1) != '/')
			{
				$baseurl .= '/';
			}
			return $baseurl.$filename;
		}
		
		function convertPodcastFileNameToSystemPath($filename = ''){
			GLOBAL $podPress;
			if(!preg_match('/^(http|https):/i' ,$filename)) {
				$filename = $podPress->settings['audioFilePath'].'/'.$filename;
				if(file_exists($filename))
				{
					return $filename;
				}
			}
			return false;
		}

		function getLengthAttrib($filename) {
			$filepath = $this->convertPodcastFileNameToSystemPath($filename);
			if($filepath){
				return ' length="'.filesize ($filepath).'"';
			} else {
				return '';
			}
		}
		
		function getTags($varname, $input = false)
		{
			$result = '';
			$showStandardAudio = false;
			$showEnhancedAudio = false;
			$showVideo = false;
			$showEbook = false;
			switch($varname) {
				case 'enclosure':
					if(isset($_GET['format'])) {
						$desiredFormat = $_GET['format'];
					} elseif(isset($this->settings['defaultFeedFormat'])) {
						$desiredFormat = $this->settings['defaultFeedFormat'];
					} else {
						$desiredFormat = 'all';
					}
					switch(strtolower($desiredFormat)) {
						case 'mp3':
							$showStandardAudio = true;
							break;
						case 'audio':
							if(get_post_meta($input, 'podPress_podcastEnhancedAudio', true)) {
								$showEnhancedAudio = true;
							} else {
								$showStandardAudio = true;
							}
							break;
						case 'video':
							$showVideo = true;
							break;
						case 'ebook':
							$showVideo = true;
							break;
						case 'all':
						default:
							$showStandardAudio = true;
							$showEnhancedAudio = true;
							$showVideo = true;
							$showEbook = true;
					}

					
					if($showStandardAudio && $filename = get_post_meta($input, 'podPress_podcastStandardAudio', true)) {
						$result .= '<enclosure url="'.$this->convertPodcastFileNameToWebPath($filename).'"'.$this->getLengthAttrib($filename).' type="audio/mpeg"/>'."\n";	
					}

					if($showEnhancedAudio && $filename = get_post_meta($input, 'podPress_podcastEnhancedAudio', true)) {
						$result .= '<enclosure url="'.$this->convertPodcastFileNameToWebPath($filename).'"'.$this->getLengthAttrib($filename).' type="audio/mp4"/>'."\n";	
					}

					if($showVideo && $filename = get_post_meta($input, 'podPress_podcastVideo', true)) {
						$result .= '<enclosure url="'.$this->convertPodcastFileNameToWebPath($filename).'"'.$this->getLengthAttrib($filename).' type="video/mp4"/>'."\n";	
					}

					if($showEbook && $filename = get_post_meta($input, 'podPress_podcastEbook', true)) {
						$result .= '<enclosure url="'.$this->convertPodcastFileNameToWebPath($filename).'"'.$this->getLengthAttrib($filename).' type="application/pdf"/>'."\n";	
					}
					break;
				case 'itunesKeywords':
					if(get_option('itunesUseKeyword')) {
						$allkeys = get_post_meta($input, 'itunes:keywords', true);
					} else {
						$categories = get_the_category();
						foreach ($categories as $category) {
							$category->cat_name = convert_chars($category->cat_name);
							$allkeys = $allkeys . $category->cat_name . ",";			
						}
						$allkeys = trim($allkeys);
					}
					$result = '<itunes:keywords>'.$allkeys.'</itunes:keywords>'."\n";	
					break;
				case 'itunesExplicit':
					$value = get_post_meta($input, 'itunes:explicit', true);

					if(!empty($value)) {
						$result = '<itunes:explicit>'.$value.'</itunes:explicit>'."\n";
					} else {
						$result = '<itunes:explicit>'.$this->settings['itunesDefaultExplicit'].'</itunes:explicit>'."\n";
					}
					break;
				case 'itunesBlock':
					$value = get_post_meta($input, 'itunes:block', true);
					if(!empty($value)) {
						$result =  '<itunes:block>'.$value.'</itunes:block>'."\n";
					} else {
						$result =  '<itunes:block>No</itunes:block>'."\n";
					}
					break;
				case 'itunesDuration':
					$value = get_post_meta($input, 'itunes:duration', true);
					if(!empty($value)) {
						$result =  '<itunes:duration>'.$value.'</itunes:duration>'."\n";
					}
					break;
				case 'itunesCategory':
					$result = '';
					$thiscat = get_option('itunesCategory1');
					if(!empty($thiscat))
					{
						if(strstr($thiscat, ':')) {
							list($cat, $subcat) = explode(":", $thiscat);
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $cat).'">'."\n";
							$result .= '  <itunes:category text="'.str_replace('&', '&amp;', $subcat).'"/>'."\n";
							$result .= '</itunes:category>'."\n";
						}
						else
						{
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $thiscat).'"/>'."\n";
						}
					}
					$thiscat = get_option('itunesCategory2');
					if(!empty($thiscat))
					{
						if(strstr($thiscat, ':')) {
							list($cat, $subcat) = explode(":", $thiscat);
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $cat).'">'."\n";
							$result .= '  <itunes:category text="'.str_replace('&', '&amp;', $subcat).'"/>'."\n";
							$result .= '</itunes:category>'."\n";
						}
						else
						{
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $thiscat).'"/>'."\n";
						}
					}
					$thiscat = get_option('itunesCategory3');
					if(!empty($thiscat))
					{
						if(strstr($thiscat, ':')) {
							list($cat, $subcat) = explode(":", $thiscat);
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $cat).'">'."\n";
							$result .= '  <itunes:category text="'.str_replace('&', '&amp;', $subcat).'"/>'."\n";
							$result .= '</itunes:category>'."\n";
						}
						else
						{
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $thiscat).'"/>'."\n";
						}
					}

					break;
				default:
					$result = '';
			}
			return $result;
		}
		

		/*************************************************************/
		/* Load up the plugin values and get ready to action         */
		/*************************************************************/
		function getPodcastTagValue($haystack) {
			if(preg_match($this->podcastTag_regexp, $haystack, $matches))
			{
				return $matches[1];
			}
			return false;
		}

		/*************************************************************/
		/* Load up the plugin values and get ready to action         */
		/*************************************************************/

		function insert_player_widgets($content = '') {
			GLOBAL $id;
			mt_srand(crc32(microtime()));
			if(is_feed()) {
				return str_replace($this->podcastTag,'',$content);
			}

			$hasLocationDefined = (bool)strstr($content, $this->podcastTag);
			if(!$hasLocationDefined && $this->settings['beforeMore'] == 'no' && strstr($content, '#more')) {
				return $content;
			}

			if(!$hasLocationDefined) {
				$content .= $this->podcastTag;
			}
			$podPressPlayBlockScripts = '<script language="javascript">';
			$podPressPlayBlock = '';
			$podPressContent = '';
			$randID = mt_rand(1, 9999);
			
			$showmp3player = false;
			$mediafile = get_post_meta($id, 'podPress_podcastStandardAudio', true);
			$format = strtolower(substr($mediafile, -3, 3));
			if($mediafile) {
				$showmp3player = $mediafile;
				$podPressContent .= __('Standard Podcast', 'podpress').' (MP3): ';
				if($format != 'm4a' &&  $format != 'm4v') {
					$podPressContent .= "<a href=\"#\" onClick=\"podPressLoadPageIntoDiv('podPressPlayerSpace_$randID', 'podPressPlayerAutoPlay=yes&standalone=no&action=showplayer&filename=".urlencode($mediafile)."'); podPressShowHidePlayerDiv('podPressPlayerSpace_$randID', 'mp3Player'); return false;\"><span id=\"podPressPlayerSpace_".$randID."_label_mp3Player\">".__('Play Now', 'podpress')."</span></a> | ";
					$podPressContent .= "<a href=\"#\" onClick=\"window.open ('".get_settings('siteurl')."/wp-content/plugins/podpress/backend.php?podPressPlayerAutoPlay=yes&standalone=yes&action=showplayer&filename=".urlencode($mediafile)."', 'podPressPlayer', 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=1,width=310,height=20'); return false;\">".__('Play in Popup', 'podpress')."</a> | ";
				}
				$podPressContent .= '<a href="' . $this->convertPodcastFileNameToWebPath($mediafile) . '" target="new">'.__('Download', 'podpress').'</a><br/>';
			}

			$mediafile = get_post_meta($id, 'podPress_podcastEnhancedAudio', true);
			$format = strtolower(substr($mediafile, -3, 3));
			if($mediafile) {
				$podPressContent .= __('Enhanced Podcast', 'podpress').' (MP4/M4A): ';
				if($format != 'm4a' &&  $format != 'm4v') {
					$podPressContent .= "<a href=\"#\" onClick=\"podPressLoadPageIntoDiv('podPressPlayerSpace_$randID', 'podPressPlayerAutoPlay=yes&standalone=no&action=showplayer&filename=".urlencode($mediafile)."'); podPressShowHidePlayerDiv('podPressPlayerSpace_$randID', 'enhanceAudioPlayer'); return false;\"><span id=\"podPressPlayerSpace_".$randID."_label_enhanceAudioPlayer\">".__('Play Now', 'podpress')."</span></a> | ";
					$podPressContent .= "<a href=\"#\" onClick=\"window.open ('".get_settings('siteurl')."/wp-content/plugins/podpress/backend.php?podPressPlayerAutoPlay=yes&standalone=yes&action=showplayer&filename=".urlencode($mediafile)."', 'podPressPlayer', 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=1,width=310,height=20'); return false;\">".__('Play in Popup', 'podpress')."</a> | ";
				}
				$podPressContent .= '<a href="' . $this->convertPodcastFileNameToWebPath($mediafile) . '" target="new">'.__('Download', 'podpress').'</a><br/>';
			}
			
			$mediafile = get_post_meta($id, 'podPress_podcastVideo', true);
			$format = strtolower(substr($mediafile, -3, 3));
			if($mediafile) {
				$showvideoplayer = $mediafile;
				$podPressContent .= __('Video Podcast', 'podpress').' (MP4/M4V/MOV/FLV): ';
				if($format != 'm4a' &&  $format != 'm4v') {
					$podPressContent .= "<a href=\"#\" onClick=\"podPressLoadPageIntoDiv('podPressPlayerSpace_$randID', 'podPressPlayerAutoPlay=yes&standalone=no&action=showplayer&filename=".urlencode($mediafile)."'); podPressShowHidePlayerDiv('podPressPlayerSpace_$randID', 'videoPlayer'); return false;\"><span id=\"podPressPlayerSpace_".$randID."_label_videoPlayer\">".__('Play Now', 'podpress')."</span></a> | ";
					$podPressContent .= "<a href=\"#\" onClick=\"window.open ('".get_settings('siteurl')."/wp-content/plugins/podpress/backend.php?podPressPlayerAutoPlay=yes&standalone=yes&action=showplayer&filename=".urlencode($mediafile)."', 'podPressPlayer', 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=1,width=350,height=275'); return false;\">".__('Play in Popup', 'podpress')."</a>";
				}
				if($format != 'm4a' &&  $format != 'm4v' && $format != 'flv') {
					$podPressContent .= ' | ';
				}
				if($format != 'flv') {
					$podPressContent .= '<a href="' . $this->convertPodcastFileNameToWebPath($mediafile) . '" target="new">'.__('Download', 'podpress').'</a><br/>';
				}
			}

			$mediafile = get_post_meta($id, 'podPress_podcastEbook', true);
			if($mediafile) {
				$podPressContent .= __('eBook Podcast', 'podpress').' (PDF): ';
				$podPressContent .= '<a href="' . $this->convertPodcastFileNameToWebPath($mediafile) . '" target="new">'.__('Download', 'podpress').'</a><br/>';
			}

			if($showmp3player) {
				$podPressPlayBlockScripts .= "document.getElementById('podPressPlayerSpace_".$randID."_label_mp3Player').innerHTML='Hide Player'; document.getElementById('podPressPlayerSpace_$randID').alt = 'mp3Player';";
				$podPressPlayBlock .= '<div id="podPressPlayerSpace_'.$randID.'" style="display: block;">'."\n";
				$podPressPlayBlock .= podpress_showPlayer($showmp3player);
				$podPressPlayBlock .= '</div>'."\n";
			//} elseif($showvideoplayer) {
			//	$podPressPlayBlock .= '<div id="podPressPlayerSpace_'.$randID.'" style="display: block; oftype: videoPlayer;">'."\n";
			//	$podPressPlayBlock .= podpress_showPlayer($showvideoplayer);
			//	$podPressPlayBlock .= '</div>'."\n";
			} else {
				$podPressPlayBlock .= '<div id="podPressPlayerSpace_'.$randID.'" style="display: none;">'."\n</div>\n";
			}
			$podPressPlayBlockScripts .= '</script>';
			$podPressContent = $podPressPlayBlock.$podPressContent.$podPressPlayBlockScripts;
			return str_replace($this->podcastTag,$podPressContent,$content);
		}

		/*************************************************************/
		/* Functions for editing and saving posts                    */
		/*************************************************************/

		function edit_post() {
			GLOBAL $post;
			if(($_GET['action'] == 'edit')) {
				$post_id = $_GET['post'];

				$itunesKeywords =  get_post_meta($post_id, 'itunes:keywords', true);
				$itunesExplicit =  get_post_meta($post_id, 'itunes:explicit', true);
				$itunesBlock =  get_post_meta($post_id, 'itunes:block', true);
				if(empty($itunesExplicit)) {
					$itunesExplicit = 'Default';
				}

				$standardAudioName =  get_post_meta($post_id, 'podPress_podcastStandardAudio', true);
				$enhancedAudioName =  get_post_meta($post_id, 'podPress_podcastEnhancedAudio', true);
				$videoName =  get_post_meta($post_id, 'podPress_podcastVideo', true);
				$ebookName =  get_post_meta($post_id, 'podPress_podcastEbook', true);
					
			}
			echo '<div id="podpressstuff" class="dbx-group" >'."\n";
			echo '	<fieldset id="podpressdiv" class="dbx-box">'."\n";			
			echo '		<h3 class="dbx-handle">'.__('Podcasting', 'podpress').'</h3> '."\n";
			echo '		<div class="dbx-content">'."\n";
			echo '			<fieldset style="width:100%">'."\n";
			echo '				<legend><strong>'.__('Podcasting', 'podpress').' '.__('Files', 'podpress').'</strong></legend>'."\n";
			echo '				<label><strong>'.__('Standard Audio', 'podpress').' '.__('File', 'podpress').'. (MP3'.__(' extension', 'podpress').')</strong>: </label><br />'."\n";
			echo '				<input type="hidden" id="audioWebPath" name="audioWebPath" size="0" value="'.$this->settings['audioWebPath'].'"/><br />'."\n";
			echo '				<input type="text" id="standardAudioName" name="standardAudioName" size="60" value="'.$standardAudioName.'" onChange="javascript: podPressLoadMP3FileInfo();"/><br />'."\n";
			echo '				<table border="0" width="300">'."\n";
			echo '					<tr>'."\n";
			echo '					<td width="100%" valign="top" align="left" style="background: #2685af; font-weight: bold;"><a href="javascript: podPressShowHideMP3Details();" id="mp3_details_header" style="font-weight: bold; color: white;">Show MP3 Information</a></td>'."\n";
			echo '					</tr>'."\n";
			echo '					<tr>'."\n";
			echo '						<td width="100%" style="background: white;">'."\n";
			echo '							<div id="mp3_details" style="display: none;">'."\n";
			echo '							</div>'."\n";
			echo '						</td>'."\n";
			echo '					</tr>'."\n";
			echo '				</table>'."\n";

			echo '				<label><strong>'.__('Enhanced Audio', 'podpress').' '.__('File', 'podpress').'. (MP4/M4A '.__('extensions', 'podpress').')</strong>: </label><br />'."\n";
			echo '				<input type="text" id="enhancedAudioName" name="enhancedAudioName" size="60" value="'.$enhancedAudioName.'"/><br />'."\n";

			echo '				<label><strong>'.__('Video', 'podpress').__('File', 'podpress').' '.'. (MP4/M4V/MOV/FLV '.__('extensions', 'podpress').')</strong>: </label><br />'."\n";
			echo '				<input type="text" id="videoName" name="videoName" size="60" value="'.$videoName.'"/><br />'."\n";
								
			echo '				<label><strong>'.__('Ebook', 'podpress').__('File', 'podpress').' '.'. (PDF '.__('extension', 'podpress').')</strong>: </label><br />'."\n";
			echo '				<input type="text" id="ebookName" name="ebookName" size="60" value="'.$ebookName.'"/><br />'."\n";
			echo '			</fieldset>'."\n";
			echo '			<br/>'."\n";
			echo '			<fieldset style="width:100%">'."\n";
			echo '				<legend><strong>'.__('iTunes Podcast Tags', 'podpress').'</strong></legend>'."\n";
			if(get_option('itunesUseKeyword')) {
				echo '			<p>'."\n";
				echo '				<label><strong>'.__('Keywords', 'podpress').'</strong>: '.__('Separate multiples with commas', 'podpress').'</label><br />'."\n";
				echo '				<textarea name="itunesKeywords" rows="4" cols="40" max="254">'.$itunesKeywords.'</textarea>'."\n";
				echo '			</p>'."\n";
			}
			echo '				<p>'."\n";
			echo '					<label><strong>'.__('Explicit', 'podpress').'</strong> ('.__('Headphones Required?', 'podpress').')</label><br />'."\n";
			echo '					<select name="itunesExplicit">'."\n";
			echo '						<option value="Default" '; if($itunesExplicit == 'Default') { echo 'selected="selected""';	}	echo '>'.__('Use Default', 'podpress').' ('.$this->settings['itunesDefaultExplicit'].')</option>'."\n";

			echo '						<option value="No" '; if($itunesExplicit == 'No') { echo 'selected="selected""';	}	echo '>'.__('No', 'podpress').'</option>'."\n";
			echo '						<option value="Yes" '; if($itunesExplicit == 'Yes') { echo 'selected="selected""';	}	echo '>'.__('Yes', 'podpress').'</option>'."\n";
			echo '						<option value="Clean" '; if($itunesExplicit == 'Clean') { echo 'selected="selected""';	}	echo '>'.__('Clean', 'podpress').'</option>'."\n";
			echo '					</select>'."\n";
			echo '				</p>'."\n";
			echo '				<p>'."\n";
			echo '					<label><strong>'.__('Block', 'podpress').'</strong></label><br />'."\n";
			echo '					<input type="checkbox" name="itunesBlock" '; if($itunesBlock == 'yes') { echo 'checked="checked"'; } echo ' value="yes"> '.__('Hide from iTunes', 'podpress')."\n";
			echo '				</p>'."\n";
			echo '			</fieldset>'."\n";
			echo '		</div>'."\n";
			echo '	</fieldset>'."\n";
			echo '</div>'."\n";
		}

		function save_post($post_id) {  
			delete_post_meta($post_id, 'podPress_podcastStandardAudio');
			if($_POST['standardAudioName']) { 
				add_post_meta($post_id, 'podPress_podcastStandardAudio', $_POST['standardAudioName'], true) ;
			}

			delete_post_meta($post_id, 'podPress_podcastEnhancedAudio');
			if($_POST['enhancedAudioName']) { 
				add_post_meta($post_id, 'podPress_podcastEnhancedAudio', $_POST['enhancedAudioName'], true) ;
			}

			delete_post_meta($post_id, 'podPress_podcastVideo');
			if($_POST['videoName']) { 
				add_post_meta($post_id, 'podPress_podcastVideo', $_POST['videoName'], true) ;
			}

			delete_post_meta($post_id, 'podPress_podcastEbook');
			if($_POST['ebookName']) { 

				add_post_meta($post_id, 'podPress_podcastEbook', $_POST['ebookName'], true) ;
			}

			if($_POST['itunesExplicit'] != 'Default') {
				delete_post_meta($post_id, 'itunes:explicit');
				add_post_meta($post_id, 'itunes:explicit', $_POST['itunesExplicit'], true) ;
			} else {
				delete_post_meta($post_id, 'itunes:explicit');
			}
		
			if($_POST['itunesBlock'] != 'yes') {
				$_POST['itunesBlock'] = 'no';
			}				
			delete_post_meta($post_id, 'itunes:block');
			add_post_meta($post_id, 'itunes:block', $_POST['itunesBlock'], true) ;

			if($_POST['itunesKeywords']) { 
				delete_post_meta($post_id, 'itunes:keywords');
				add_post_meta($post_id, 'itunes:keywords', $_POST['itunesKeywords'], true) ;
			}
			
			$fullMp3Path = $this->convertPodcastFileNameToSystemPath($_POST['standardAudioName']);
			if($fullMp3Path)
			{
				$getID3 = $this->loadID3();
				if($getID3){
					$fileinfo = $getID3->analyze($fullMp3Path);
					delete_post_meta($post_id, 'itunes:duration');
					add_post_meta($post_id, 'itunes:duration', $fileinfo['playtime_string'], true) ;
				}
			}
		}
	
		/*************************************************************/
		/* edit and save PodPress options                            */
		/*************************************************************/
		function save_options()
		{
			if(function_exists('wp_cache_flush'))
			{
				wp_cache_flush();
			}
			// settings for the player
			if(isset($_POST['podPress_audioWebPath'])) {
				if(substr($_POST['podPress_audioWebPath'], -1) == '/')
				{
					$_POST['podPress_audioWebPath'] = substr($_POST['podPress_audioWebPath'], 0, -1);
				}
				update_option('podPress_audioWebPath', $_POST['podPress_audioWebPath']); 
			}

			if(isset($_POST['podPress_audioFilePath'])) {
				//if(substr($_POST['podPress_audioFilePath'], -1) == '/' || substr($_POST['podPress_audioFilePath'], -1) == '\\')
				//{
				//	$_POST['podPress_audioFilePath'] = substr($_POST['podPress_audioFilePath'], 0, -1);
				//}
				update_option('podPress_audioFilePath', $_POST['podPress_audioFilePath']); 
			}

			if(isset($_POST['blogdescription'])) { update_option('blogdescription', $_POST['blogdescription']); }
			
			if(isset($_POST['podcastdescription'])) { 
				if(empty($_POST['podcastdescription']) && isset($_POST['blogdescription'])) {
					update_option('blogdescription', $_POST['blogdescription']);
				} else {
					update_option('podcastdescription', $_POST['podcastdescription']); 
				}
			}

			if(isset($_POST['itunesFeedURL'])) { update_option('itunesFeedURL', $_POST['itunesFeedURL']); }
			if(isset($_POST['itunesFeedID'])) { update_option('itunesFeedID', $_POST['itunesFeedID']); }
			if(isset($_POST['itunesAdminName'])) { update_option('itunesAdminName', $_POST['itunesAdminName']); }
			if(isset($_POST['itunesAdminEmail'])) { update_option('itunesAdminEmail', $_POST['itunesAdminEmail']); }
			if(isset($_POST['itunesTTL'])) { update_option('itunesTTL', $_POST['itunesTTL']); }
			if(isset($_POST['itunesSubtitle'])) { update_option('itunesSubtitle', $_POST['itunesSubtitle']); }
			if(isset($_POST['itunesUseKeyword'])) { update_option('itunesUseKeyword', $_POST['itunesUseKeyword']); }
			if(isset($_POST['itunesFeedKeywords'])) { update_option('itunesFeedKeywords', $_POST['itunesFeedKeywords']); }
			if(isset($_POST['channelCat'])) { update_option('channelCat', $_POST['channelCat']); }

			if(isset($_POST['itunesCategory1']) && $_POST['itunesCategory1'] != '#') {
				update_option('itunesCategory1',  $_POST['itunesCategory1']); 
			}

			if(isset($_POST['itunesCategory2']) && $_POST['itunesCategory2'] != '#') {
				update_option('itunesCategory2',  $_POST['itunesCategory2']); 
			}

			if(isset($_POST['itunesCategory3']) && $_POST['itunesCategory3'] != '#') {
				update_option('itunesCategory3',  $_POST['itunesCategory3']); 
			}
	
			if(isset($_POST['itunesImageBig'])) { update_option('itunesImageBig', $_POST['itunesImageBig']); }
			if(isset($_POST['itunesImageSmall'])) { update_option('itunesImageSmall', $_POST['itunesImageSmall']); } 	

			if(isset($_POST['defaultFeedFormat'])) { update_option('podPress_defaultFeedFormat', $_POST['defaultFeedFormat']); } 	
	
			$commentcast = isset($_POST['itunesCommentCast']) ?
				   $_POST['itunesCommentCast'] :
				   array();


			if(count($commentcast) > 0) { 
				update_option('itunesCommentCast', 'yes'); 
			} else {
				update_option('itunesCommentCast', 'no');	 
			}

			if(isset($_POST['podPress_BeforeMore'])) { update_option('podPress_BeforeMore', $_POST['podPress_BeforeMore']); }
			
			if(isset($_POST['itunesDefaultExplicit'])) { update_option('itunesDefaultExplicit', $_POST['itunesDefaultExplicit']); }

			update_option('podPress_player_bgcolor', str_replace("#", "0x", $_POST['podPressPlayer_bgcolor']));
			update_option('podPress_player_leftbgcolor', str_replace("#", "0x", $_POST['podPressPlayer_leftbgcolor']));
			update_option('podPress_player_rightbgcolor', str_replace("#", "0x", $_POST['podPressPlayer_rightbgcolor']));
			update_option('podPress_player_rightbghovercolor', str_replace("#", "0x", $_POST['podPressPlayer_rightbghovercolor']));
			update_option('podPress_player_lefticoncolor', str_replace("#", "0x", $_POST['podPressPlayer_lefticoncolor']));
			update_option('podPress_player_righticoncolor', str_replace("#", "0x", $_POST['podPressPlayer_righticoncolor']));
			update_option('podPress_player_righticonhovercolor', str_replace("#", "0x", $_POST['podPressPlayer_righticonhovercolor']));
			update_option('podPress_player_textcolor', str_replace("#", "0x", $_POST['podPressPlayer_textcolor']));
			update_option('podPress_player_slidercolor', str_replace("#", "0x", $_POST['podPressPlayer_slidercolor']));
			update_option('podPress_player_trackcolor', str_replace("#", "0x", $_POST['podPressPlayer_trackcolor']));
			update_option('podPress_player_loadercolor', str_replace("#", "0x", $_POST['podPressPlayer_loadercolor']));
			update_option('podPress_player_bordercolor', str_replace("#", "0x", $_POST['podPressPlayer_bordercolor']));

			$location = get_option('siteurl') . '/wp-admin/admin.php?page=podpress.php';
			header('Location: '.$location);
			exit;
		}
		
		function edit_options() {

			echo '<div class="wrap">'."\n";
			echo '	<h2>'.__('Podcasting Options', 'podpress').'</h2>'."\n";
			echo '	<form action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";

			echo '	<fieldset class="options">'."\n";
			echo '		<legend>'.__('Common Podcasting Options', 'podpress').'</legend>'."\n";
			echo '		<table width="100%" cellspacing="2" cellpadding="5" class="editform">'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPress_audioWebPath">'.__('URI of audio files directory', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPress_audioWebPath" name="podPress_audioWebPath" size="40" value="'.$this->settings['audioWebPath'].'" />'."\n";
			echo '						<br/>Can be local or remote location.'."\n";
			if(!isset($this->settings['audioWebPath']) || empty($this->settings['audioWebPath'])){
				echo "<br />\n";
				echo __('Suggested', 'podpress').': <code>/audio</code>'."\n";
			}
					
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPress_audioFilePath">'.__('Local path to audio files directory (optional)', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPress_audioFilePath" name="podPress_audioFilePath" size="40" value="'.$this->settings['audioFilePath'].'" /><br />'."\n";
			echo '						'.__('Used to get the MP3 file sizes content duration', 'podpress')."\n";
			if(isset($this->settings['autoDetectedaudioFilePath'])){
				echo "<br/>\n";
				echo __('Directory Not Valid or Not Accessible', 'podpress').'<br/> '.__('Suggested', 'podpress').': <code>'.$this->settings['autoDetectedaudioFilePath'].'</code>'."\n";
			}
			echo '							</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPress_description">'.__('Podcast Description', 'podpress').'</label></th>'."\n";
			echo '				<td><textarea type="text" id="podcastdescription" name="podcastdescription" max="255" id="podcastdescription" rows="4" cols="40" onChange="podPress_updateItunesPreview();">'.$this->settings['podcastdescription'].'</textarea><br />('.__('Used as iTunes description', 'podpress').')</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPress_description">'.__('Blog Description', 'podpress').'</label></th>'."\n";
			echo '				<td><textarea type="text" id="blogdescription" name="blogdescription" max="255" id="blogdescription" rows="4" cols="40" onChange="podPress_updateItunesPreview();">'.$this->settings['blogdescription'].'</textarea><br />('.__('Standard feed description', 'podpress').')</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label>'.__('Podcast Cover Image URLs', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<table width="100%" cellspacing="2" cellpadding="5" class="editform">'."\n";
			echo '						<tr valign="top"> '."\n";
			echo '							<td>'."\n";
			echo '								<b>'.__('Big', 'podpress').' (300*300 pixels)</b><br/>'."\n";
			echo '								<input id="itunesImageBig" type="text" name="itunesImageBig" value="'; if($this->settings['itunesImageBig']) {	echo $this->settings['itunesImageBig']; } else { echo get_settings('siteurl'); } echo '" size="40" onChange="podPress_updateImage(\'itunesImageBigDisplay\', this.value); podPress_updateItunesImage();"/>'."\n";
			echo '							<br /><img id="itunesImageBigDisplay" width="300" height="300" alt="Podcast Image - Big"/>'."\n";
			echo '							</td>'."\n";
			echo '						</tr>'."\n";
			echo '						<tr valign="top">'."\n";
			echo '							<td>'."\n";
			echo '								<b>'.__('Small', 'podpress').' (144*144 pixels)</b><br/>'."\n";
			echo '								<input id="itunesImageSmall" type="text" name="itunesImageSmall" value="'; if($this->settings['itunesImageSmall']) { echo $this->settings['itunesImageSmall']; } else { echo get_settings('siteurl'); } echo '" size="40" onChange="podPress_updateImage(\'itunesImageSmallDisplay\', this.value); podPress_updateItunesImage();"/>'."\n";
			echo '								<br /><img id="itunesImageSmallDisplay" width="144" height="144" alt="Podcast Image - Small"/>'."\n";
			echo "<script> podPress_updateImage('itunesImageBigDisplay', document.getElementById('itunesImageBig').value); podPress_updateImage('itunesImageSmallDisplay', document.getElementById('itunesImageSmall').value);</script>";
			echo '							</td>'."\n";
			echo '						</tr>'."\n";
			echo '					</table>'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">'.__('Channel Category', 'podpress').'</th> '."\n";
			echo '				<td><input name="channelCat" type="text" id="channelCat" value="'.$this->settings['channelCat'].'" size="45%" /><br />Anything you want. This is for everyone except iTunes.</td>'."\n";
			echo '			</tr>'."\n";

			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">'.__('Comments Feed Podcast', 'podpress').'</th>'."\n";
			echo '				<td><input type="checkbox" name="itunesCommentCast" id="itunesCommentCast" '.$this->settings['itunesCommentCast'].'/> Yeah, Im comment-casting. <em>(Use the replacement wp-commentsrss2.php file)</em></td>'."\n";
			echo '			</tr> '."\n";

			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">'.__('Default Feed Format', 'podpress').'</th> '."\n";
			echo '				<td>'."\n";
			echo '					<select name="defaultFeedFormat">'."\n";
			echo '						<option value="all" '; if($this->settings['defaultFeedFormat'] == 'all') { echo 'selected="selected""'; } echo '>'.__('All', 'podpress').'</option>'."\n";
			echo '						<option value="mp3" '; if($this->settings['defaultFeedFormat'] == 'mp3') { echo 'selected="selected""'; }  echo '>'.__('Standard Audio', 'podpress').' (MP3)</option>'."\n";
			echo '						<option value="audio" '; if($this->settings['defaultFeedFormat'] == 'audio') { echo 'selected="selected""'; }  echo '>'.__('Enhanced Audio', 'podpress').' (MP4, M4A)</option>'."\n";
			echo '						<option value="video" '; if($this->settings['defaultFeedFormat'] == 'video') { echo 'selected="selected""'; }  echo '>'.__('Video', 'podpress').' (MP4, M4V, MOV, FLV)</option>'."\n";
			echo '						<option value="ebook" '; if($this->settings['defaultFeedFormat'] == 'ebook') { echo 'selected="selected""'; }  echo '>'.__('eBook', 'podpress').' (PDF)</option>'."\n";
			echo '					</select> '.__('This defines the enclosure tags that will be included by default', 'podpress')."\n";
			echo '				</td>'."\n";
			echo '			</tr> '."\n";

			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">Before &lt;!- More -&gt; tag</th> '."\n";
			echo '				<td>'."\n";
			echo '					<select name="podPress_BeforeMore">'."\n";
			echo '						<option value="yes" '; if($this->settings['beforeMore'] == 'yes') { echo 'selected="selected""'; } echo '>'.__('Yes', 'podpress').'</option>'."\n";
			echo '						<option value="no" '; if($this->settings['beforeMore'] != 'yes') { echo 'selected="selected""'; }  echo '>'.__('No', 'podpress').'</option>'."\n";
			echo '					</select> '.__('This defines that the Podcast player and download links will always be visible on the short version of the Post', 'podpress')."\n";
			echo '				</td>'."\n";
			echo '			</tr> '."\n";
			
			echo '		</table>'."\n";
			echo '	</fieldset>'."\n";
		
			echo '	<p class="submit"> '."\n";
			echo '	<input type="submit" name="Submit" value="'.__('Update Options', 'podpress').' &raquo;" /> '."\n";
			echo '	</p> '."\n";

			echo '	<fieldset class="options">'."\n";
			echo '		<legend>'.__('iTunes Options', 'podpress').'</legend>'."\n";
			echo '		<table width="100%" cellspacing="2" cellpadding="5" class="editform">'."\n";

			echo '			<tr valign="top"> '."\n";
			echo '				<th width="33%" scope="row">iTunes:FeedURL</th>'."\n";
			echo '				<td><input name="itunesFeedURL" type="text" id="itunesFeedURL" value="'.stripslashes($this->settings['itunesFeedURL']).'" size="40" /></td> '."\n";
			echo '			</tr>'."\n";

			echo '			<tr valign="top"> '."\n";
			echo '				<th width="33%" scope="row">iTunes:FeedID</th>'."\n";
			echo '				<td>'."\n";
			echo '					<input name="itunesFeedID" type="text" id="itunesFeedID" value="'.stripslashes($this->settings['itunesFeedID']).'" size="10" />'."\n";
			echo '						<!--<input type="button" name="Ping_iTunes_update" value="Ping iTunes Update" onClick="pingITunesUpdate()"/>-->'."\n";
			echo '					<div id="iTunesPingResult" style="visibility: hidden;">'.__('Ping iTunes server to update your podcast information', 'podpress').' - '.__('Complete', 'podpress').'!</div>'."\n";
			echo '				</td> '."\n";
			echo '			</tr>'."\n";
			
			echo '			<tr valign="top"> '."\n";
			echo '				<th width="33%" scope="row">iTunes:Subtitle</th>'."\n";
			echo '				<td><textarea type="text" name="itunesSubtitle" max="255" id="itunesSubtitle" rows="4" cols="40">'.stripslashes($this->settings['itunesSubtitle']).'</textarea><br />('.__('Used as default Podcast Episode Title', 'podpress').')<br />(255 '.__('characters', 'podpress').')</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">iTunes:Keywords</th>'."\n";
			echo '				<td>'."\n";
			echo '					<fieldset style="width:60%">'."\n";
			echo '						<label> '.__('Keywords for the entire feed', 'podpress').'. </label><textarea name="itunesFeedKeywords" rows="4" cols="40" max="254">'.stripslashes($this->settings['itunesFeedKeywords']).'</textarea>'."\n";
			echo '						<br />'."\n";
			echo '						'.__('Set per Post keywords', 'podpress').':<br/>'."\n";
			echo '						<label><input name="itunesUseKeyword"  type="radio" value="0" '; if(!$this->settings['itunesUseKeyword']) { echo 'checked="checked"'; } echo ' /> '.__('Using WordPress Categories', 'podpress').'</label>'."\n";
			echo '						<br />'."\n";
			echo '						<label><input name="itunesUseKeyword" type="radio" value="1" '; if($this->settings['itunesUseKeyword']) { echo 'checked="checked"'; } echo ' /> '.__('By hand', 'podpress').'</label>'."\n";
			echo '					</fieldset>'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
		
			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">iTunes:Categories</th> '."\n";
			echo '				<td>'."\n";
			echo '					<select id="itunesCategory1" name="itunesCategory1" onChange="podPress_updateItunesPreview();">'."\n";
			echo '						<option value="#">'.__('Select Primary', 'podpress').'</option>'."\n";
			$this->itunesCategoryOptions($this->settings['itunesCategory1']);
			echo '					</select>'."\n";
			echo '					<select name="itunesCategory2">'."\n";
			echo '						<option value="#">'.__('Select Second', 'podpress').'</option>'."\n";
			$this->itunesCategoryOptions($this->settings['itunesCategory2']);
			echo '					</select>'."\n";
			echo '					<select name="itunesCategory3">'."\n";
			echo '						<option value="#">'.__('Select Third', 'podpress').'</option>'."\n";
			$this->itunesCategoryOptions($this->settings['itunesCategory3']);
			echo '					</select>'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";

			echo '			<tr valign="top"> '."\n";
			echo '				<th width="33%" scope="row">'.__('Owner Name', 'podpress').':</th> '."\n";
			echo '				<td><input id="itunesAdminName" name="itunesAdminName" type="text" id="itunesAdminName" value="'.stripslashes($this->settings['itunesAdminName']).'" size="40" onChange="podPress_updateItunesPreview();"/></td> '."\n";
			echo '	  	</tr>'."\n";
			echo '		  <tr valign="top"> '."\n";
			echo '				<th width="33%" scope="row">'.__('Owner E-mail address', 'podpress').':</th> '."\n";
			echo '				<td><input name="itunesAdminEmail" type="text" id="itunesAdminEmail" value="'; if($this->settings['itunesAdminEmail']) { echo $this->settings['itunesAdminEmail']; } else { form_option('admin_email'); } echo '" size="40" /></td> '."\n";
			echo '			</tr>'."\n";
			
			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">iTunes:Explicit</th>'."\n";
			echo '				<td>'."\n";
			echo '					<select name="itunesDefaultExplicit">'."\n";
			echo '						<option value="No" '; if($this->settings['itunesDefaultExplicit'] == 'No') { echo 'selected="selected""'; } echo '>'.__('No', 'podpress').'</option>'."\n";
			echo '						<option value="Yes" '; if($this->settings['itunesDefaultExplicit'] == 'Yes') { echo 'selected="selected""'; } echo '>'.__('Yes', 'podpress').'</option>'."\n";
			echo '						<option value="Clean" '; if($this->settings['itunesDefaultExplicit'] == 'Clean') { echo 'selected="selected""'; } echo '>'.__('Clean', 'podpress').'</option>'."\n";
			echo '					</select> '.__('This defines the default that will be used. Each show can have its own Explicit rating', 'podpress').'.'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";

			echo '			<tr valign="top">'."\n";
			echo '				<th width="33%" scope="row">iTunes:TTL (time-to-live)</th>'."\n";
			echo '				<td><input name="itunesTTL" type="text" id="itunesTTL" value="'; if($this->settings['itunesTTL']) { echo $this->settings['itunesTTL']; } else { echo '1440'; } echo '" size="4" /> ('.__('Mins. Default is 24hrs which is 1440 mins', 'podpress').')</td> '."\n";
			echo '			</tr>'."\n";
			echo '		</table>'."\n";
			echo '	</fieldset>'."\n";

			echo '	<p class="submit"> '."\n";
			echo '	<input type="submit" name="Submit" value="'.__('Update Options', 'podpress').' &raquo;" /> '."\n";
			echo '	</p> '."\n";

			echo '	<fieldset class="options">'."\n";
			echo '		<legend>'.__('iTunes Preview', 'podpress').'</legend>'."\n";

			echo '		<table width="100%" cellspacing="2" cellpadding="5" class="editform" bgcolor="#C5A4E0">'."\n";
			echo '			<tr valign="top">'."\n";
			echo '				<td><img id="iTunesPreviewImage" width="300" height="300" alt="Podcast Image"/></td>'."\n";
			echo '				<td>'."\n";
			echo '					<b><font size="+1">'; bloginfo_rss('name'); echo '</font></b><br/><span id="itunesAdminNamePreview"></span>'."\n";
			echo '					<br/>'."\n";
			echo '					<br/>'."\n";
			echo '					<br/>'."\n";
			echo '					<br/>'."\n";
			echo '					<br/>'."\n";
			echo '					<font size="-1">'."\n";
			echo '						Total: x episodes<br/>'."\n";
			echo '						Category: <span id="itunesCategoryPreview"></span><br/>'."\n";
			echo '						Language: English</br>'."\n";
			echo '						</br>'."\n";
			echo '						<img src="http://www.mightyseek.com/images/itunes-subscribebutton.gif" border="0" alt="iTunesSubscriptions" /> '."\n";
			echo '					</font>'."\n";
			echo '				</td>'."\n";
			echo '				<td><img src="http://www.mightyseek.com/images/vert-bar.gif" border="0" width="2" height="300" alt="vertbar"/>&nbsp;</td>'."\n";
			echo '				<td>'."\n";
			echo '					<b><font size="+1">Podcast Description</font></b><br/>'."\n";
			echo '					<font size="-1"><span id="itunesDescriptionPreview"></span></font>'."\n";
			echo '						<br/>'."\n";
			echo '						<br/>'."\n";
			echo '						<img src="http://www.mightyseek.com/images/iTunes_websiteandreportconcern.jpg" border="0" alt="iTunesReport" /> 	'."\n";					
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '		</table>'."\n";
			echo "<script> podPress_updateItunesPreview();</script>";			
			echo '	</fieldset>'."\n";

			echo '	<br />'."\n";

			echo '	<fieldset class="options">'."\n";
			echo '		<legend>'.__('MP3 Player Colors', 'podpress').'</legend>'."\n";
			echo '		<p>'."\n";

			echo '		<table class="editform" cellpadding="5" cellspacing="2" width="100%">'."\n";
			echo '			<tr>'."\n";
			echo '				<th>'.__('Colour map', 'podpress').':</th>'."\n";
			echo '				<td><img src="'.get_settings('siteurl').'/wp-content/plugins/podpress/map.gif" width="390" height="124" alt="podpress map" /></td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_bgcolor">'.__('Background', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_bgcolor" name="podPressPlayer_bgcolor" size="40" value="'.$this->playerOptions['bg'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_leftbgcolor">'.__('Left background', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_leftbgcolor" name="podPressPlayer_leftbgcolor" size="40" value="'.$this->playerOptions['leftbg'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_rightbgcolor">'.__('Right background', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_rightbgcolor" name="podPressPlayer_rightbgcolor" size="40" value="'.$this->playerOptions['rightbg'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_rightbghovercolor">'.__('Right background (hover)', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_rightbghovercolor" name="podPressPlayer_rightbghovercolor" size="40" value="'.$this->playerOptions['rightbghover'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_lefticoncolor">'.__('Left icon', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_lefticoncolor" name="podPressPlayer_lefticoncolor" size="40" value="'.$this->playerOptions['lefticon'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_righticoncolor">'.__('Right icon', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_righticoncolor" name="podPressPlayer_righticoncolor" size="40" value="'.$this->playerOptions['righticon'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_righticonhovercolor">'.__('Right icon (hover)', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_righticonhovercolor" name="podPressPlayer_righticonhovercolor" size="40" value="'.$this->playerOptions['righticonhover'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_iconcolor">'.__('Text', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_textcolor" name="podPressPlayer_textcolor" size="40" value="'.$this->playerOptions['text'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_slidercolor">'.__('Slider', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_slidercolor" name="podPressPlayer_slidercolor" size="40" value="'.$this->playerOptions['slider'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_trackcolor">'.__('Progress bar track', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_trackcolor" name="podPressPlayer_trackcolor" size="40" value="'.$this->playerOptions['track'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_loadercolor">'.__('Loader bar', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_loadercolor" name="podPressPlayer_loadercolor" size="40" value="'.$this->playerOptions['loader'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '			<tr>'."\n";
			echo '				<th width="33%" valign="top"><label for="podPressPlayer_bordercolor">'.__('Progress bar border', 'podpress').':</label></th>'."\n";
			echo '				<td>'."\n";
			echo '					<input type="text" id="podPressPlayer_bordercolor" name="podPressPlayer_bordercolor" size="40" value="'.$this->playerOptions['border'].'" /><br />'."\n";
			echo '				</td>'."\n";
			echo '			</tr>'."\n";
			echo '		</table>'."\n";

			echo '		</p>'."\n";
			echo '	</fieldset>'."\n";

			echo '	<input type="hidden" name="submitted" value="submitted" />'."\n";
			echo '	<p class="submit"> '."\n";
			echo '	<input type="submit" name="Submit" value="'.__('Update Options', 'podpress').' &raquo;" /> '."\n";
			echo '	</p> '."\n";
			echo '	</form> '."\n";
			echo '</div>'."\n";

			//end of edit_options function
		}	


		///// THIS IS FOR ENABLING COMMENT-PODCASTS ////
		function comment_do_enclose($comment_ID) {
			global $wp_version, $wpdb;

			$comment = $wpdb->get_var(
				"SELECT comment_content FROM $wpdb->comments ".
				"WHERE comment_ID = '$comment_ID'"
			);
	
			$post_ID = $wpdb->get_var(
				"SELECT comment_post_ID FROM $wpdb->comments ".
				"WHERE comment_ID = '$comment_ID'"
			);
		
			include_once (ABSPATH . WPINC . '/class-IXR.php');

			$log = debug_fopen(ABSPATH . '/enclosures.log', 'a');
			$post_links = array();
			debug_fwrite($log, 'BEGIN '.date('YmdHis', time())."\n");

			$pung = $this->getCommentEnclosed($comment_ID, $post_ID);

			$ltrs = '\w';
			$gunk = '/#~:.?+=&%@!\-';
			$punc = '.:?\-';
			$any = $ltrs . $gunk . $punc;

			preg_match_all("{\b http : [$any] +? (?= [$punc] * [^$any] | $)}x", $comment, $comment_links_temp);

			debug_fwrite($log, 'Comment contents:');
			debug_fwrite($log, $commentInfo->comment_content."\n");

			foreach($comment_links_temp[0] as $link_test) :
				if(!in_array($link_test, $pung)) : // If we haven't pung it already
					$test = parse_url($link_test);
					if(isset($test['query']))
						$comment_links[] = $link_test;
					elseif(($test['path'] != '/') && ($test['path'] != ''))
						$comment_links[] = $link_test;
				endif;
			endforeach;

			foreach ($comment_links as $url) :
				if($url != '' && !$wpdb->get_var("SELECT post_id FROM $wpdb->postmeta WHERE post_id = '$post_ID' AND meta_key = 'com-enclosure' AND meta_value LIKE ('$url%')")) {
					if($headers = wp_get_http_headers($url)) {
						$len  = (int) $headers['content-length'];
						$type = addslashes($headers['content-type']);
						$allowed_types = array('video','audio');
				
						if(in_array(substr($type, 0, strpos($type, "/")), $allowed_types)) {
							$meta_value = "$comment_ID\n$url\n$len\n$type\n";				
							$wpdb->query("INSERT INTO `$wpdb->postmeta` (`post_id` , `meta_key` , `meta_value`)
							VALUES ('$post_ID', 'com-enclosure' , '$meta_value')");
						}
					}
				}
			endforeach;
		}

		// Get enclosures already enclosed for a comment
		function getCommentEnclosed ($comment_id, $post_id) {
			$custom_fields = get_post_custom($post_id);
			$pung = array();
	
			if(is_array($custom_fields)) {
				while(list($key, $val) = each($custom_fields)) { 
					if($key == 'com-enclosure') {
						if(is_array($val)) {
							foreach($val as $enc) {
								$enclosure = split("\n", $enc);
								if(trim($enclosure[0]) == $comment_id) {
								  $pung[] = trim($enclosure[0]);
								}
							}
						}
					}
				}
			}
			return $pung;
		}


		// Get enclosures already enclosed for a comment
		function getCommentEnclosure($comment_ID, $post_ID) {
			$enclosureTag = '';
			$custom_fields = get_post_custom($post_ID);
			$pung = array();
	
			if(is_array($custom_fields)) {
				while(list($key, $val) = each($custom_fields)) { 
					if($key == 'com-enclosure') {
						if(is_array($val)) {
							foreach($val as $enc) {
								$enclosure = split("\n", $enc);
								if(trim($enclosure[0]) == $comment_ID) {
								  $enclosureTag = '<enclosure url="'.$enclosure[1].'" length="'.$enclosure[2].'" type="'.$enclosure[3].'" />';
								}
							}
						}
					}
				}
			}
			return $enclosureTag;
		}

		function itunesCategoryOptions($current = '') {
			$cats = array();

			$cats['Arts & Entertainment'] = 'Arts & Entertainment';
			$cats['Arts & Entertainment:Architecture'] = 'Arts & Entertainment:Architecture';
			$cats['Arts & Entertainment:Books'] = 'Arts & Entertainment:Books';
			$cats['Arts & Entertainment:Design'] = 'Arts & Entertainment:Design';
			$cats['Arts & Entertainment:Entertainment'] = 'Arts & Entertainment:Entertainment';
			$cats['Arts & Entertainment:Games'] = 'Arts & Entertainment:Games';
			$cats['Arts & Entertainment:Performing Arts'] = 'Arts & Entertainment:Performing Arts';
			$cats['Arts & Entertainment:Photography'] = 'Arts & Entertainment:Photography';
			$cats['Arts & Entertainment:Science Fiction'] = 'Arts & Entertainment:Science Fiction';

			$cats['Audio Blogs'] = 'Audio Blogs';

			$cats['Business'] = 'Business';
			$cats['Business:Careers'] = 'Business:Careers';
			$cats['Business:Finance'] = 'Business:Finance';
			$cats['Business:Investing'] = 'Business:Investing';
			$cats['Business:Management'] = 'Business:Management';
			$cats['Business:Marketing'] = 'Business:Marketing';

			$cats['Comedy'] = 'Comedy';

			$cats['Education'] = 'Education';
			$cats['Education:K-12'] = 'Education:K-12';
			$cats['Education:Higher Education'] = 'Education:Higher Education';

			$cats['Food'] = 'Food';

			$cats['Health'] = 'Health';
			$cats['Health:Diet & Nutrition'] = 'Health:Diet & Nutrition';
			$cats['Health:Fitness'] = 'Health:Fitness';
			$cats['Health:Relationships'] = 'Health:Relationships';
			$cats['Health:Self-Help'] = 'Health:Self-Help';
			$cats['Health:Sexuality'] = 'Health:Sexuality';

			$cats['International'] = 'International';
			$cats['International:Australian'] = 'International:Australian';
			$cats['International:Belgian'] = 'International:Belgian';
			$cats['International:Brazilian'] = 'International:Brazilian';
			$cats['International:Canadian'] = 'International:Canadian';
			$cats['International:Chinese'] = 'International:Chinese';
			$cats['International:Dutch'] = 'International:Dutch';
			$cats['International:French'] = 'International:French';
			$cats['International:German'] = 'International:German';
			$cats['International:Hebrew'] = 'International:Hebrew';
			$cats['International:Italian'] = 'International:Italian';
			$cats['International:Japanese'] = 'International:Japanese';
			$cats['International:Norwegian'] = 'International:Norwegian';
			$cats['International:Polish'] = 'International:Polish';
			$cats['International:Portuguese'] = 'International:Portuguese';
			$cats['International:Spanish'] = 'International:Spanish';
			$cats['International:Swedish'] = 'International:Swedish';

			$cats['Movies & Television'] = 'Movies & Television';
			$cats['Movies & Television:News'] = 'Movies & Television:News';
			$cats['Movies & Television:Politics'] = 'Movies & Television:Politics';
			$cats['Movies & Television:Public Radio'] = 'Movies & Television:Public Radio';

			$cats['Music'] = 'Music';

			$cats['Religion & Spirituality'] = 'Religion & Spirituality';
			$cats['Religion & Spirituality:Buddhism'] = 'Religion & Spirituality:Buddhism';
			$cats['Religion & Spirituality:Christianity'] = 'Religion & Spirituality:Christianity';
			$cats['Religion & Spirituality:Islam'] = 'Religion & Spirituality:Islam';
			$cats['Religion & Spirituality:Judaism'] = 'Religion & Spirituality:Judaism';
			$cats['Religion & Spirituality:New Age'] = 'Religion & Spirituality:New Age';
			$cats['Religion & Spirituality:Philosophy'] = 'Religion & Spirituality:Philosophy';
			$cats['Religion & Spirituality:Spirituality'] = 'Religion & Spirituality:Spirituality';

			$cats['Science'] = 'Science';

			$cats['Sports'] = 'Sports';

			$cats['Talk Radio'] = 'Talk Radio';

			$cats['Technology'] = 'Technology';
			$cats['Technology:Computers'] = 'Technology:Computers';
			$cats['Technology:Developers'] = 'Technology:Developers';
			$cats['Technology:Gadgets'] = 'Technology:Gadgets';
			$cats['Technology:Information'] = 'Technology:Information';
			$cats['Technology:News'] = 'Technology:News';
			$cats['Technology:Operating Systems'] = 'Technology:Operating Systems';
			$cats['Technology:Podcasting'] = 'Technology:Podcasting';
			$cats['Technology:Smart Phones'] = 'Technology:Smart Phones';
			$cats['Technology:Text/Speech'] = 'Technology:Text/Speech';

			$cats['Travel'] = 'Travel';
	
			reset($cats);
	
			foreach ($cats as $key => $value) {
				echo '<option value="'.$key.'"';
				if($key == $current) {
					echo ' selected="selected"';
				}
				echo ';>'.$value.'</option>'."\n";
			}
		}
	// *** End of podPress Class ***
	}



	/*************************************************************/
	/* Simple wrapper functions, since I dont think I can        */
	/* register object functions                                 */
	/*************************************************************/
	function podPress_insert_player_widget($content = '') {
		GLOBAL $podPress;
		return $podPress->insert_player_widgets($content);
	}

	function podPress_edit_post() {
		GLOBAL $podPress;
		return $podPress->edit_post();
	}

	function podPress_save_post($post_id) {
		GLOBAL $podPress;
		return $podPress->save_post($post_id);
	}

	function podPress_comment_do_enclose($comment_ID) {
		GLOBAL $podPress;
		return $podPress->comment_do_enclose($comment_ID);
	}


	/* Add podPress Tab to Options Menu */
	function podPress_add_options_page() {
		if(function_exists('add_options_page')) { 
			add_options_page('podPress Configuration', 'PodPress', 5, basename(__FILE__)); 
//			add_submenu_page('post.php','test', 'test_title', 0, 'testfile');
		}
	}

	function podPress_javascript() {
		echo '<script><!--'."\n";
		echo 'var podPressBackendURL = "'.get_option('siteurl').'/wp-content/plugins/podpress/backend.php?";'."\n";
		echo '--></script>'."\n";
		echo '<script language="javascript" type="text/javascript" src="' . get_settings("siteurl") . '/wp-content/plugins/podpress/podpress.js"></script>'."\n";
	}
	
	if(!function_exists('html_print_r')) {
		function html_print_r($v, $n = '') {
			echo $n.'<pre>';
			print_r($v);
			echo '</pre>';
		}
	}
}

	/*************************************************************/
	/* !!! BEGINNING OF THE ACTION !!!                           */
	/*************************************************************/
	require_once('podpress/backend.php');
	
	/*************************************************************/
	/* Create the podPress object                                */
	/*************************************************************/
		
	if(!is_object ($podPress) || get_class($podPress) != 'podpress_plugin') {
		if(!$podPress = new podpress_plugin){
			// *** THESE TWO LINES ARE HERE FOR DEBUGGING PURPOSES ONLY ***
			//echo 'cant create instance of podpress_plugin class as $podPress'."<br>\n";
			//exit;
		}
	}

	/*************************************************************/
	/* Register load blog crap                                   */
	/*************************************************************/
	if(is_plugin_page()) {
		$podPress->edit_options();
	} else {
		add_action('wp_head', 'podPress_javascript');
		add_action('admin_head', 'podPress_javascript');
		add_filter('the_content', 'podPress_insert_player_widget');
		add_filter('the_content_rss', 'podPress_insert_player_widget');

		if(isset($_POST['submitted'])) { $podPress->save_options(); }

		/* If this is an admin page, run the function to Add podPress Tab to Options Menu */
		add_action('admin_head', 'podPress_add_options_page');

		// IF NOT, RUN EVERYTHING ELSE
		add_action('simple_edit_form','podPress_edit_post');	// DISPLAYS THE FORM IN THE SIMPLE FORM
		add_action('edit_form_advanced','podPress_edit_post');	// DISPLAYS THE FORM IN THE ADVANCED FORM
		add_action('save_post','podPress_save_post');		// UPDATES AND SAVES THE POST
		add_action('edit_post','podPress_save_post');		// UPDATES AND SAVES THE POST

		if(get_option('itunesCommentCast') == "yes") {
			add_action('comment_post','podPress_comment_do_enclose');  // CHECKS THE COMMENT FOR ENCLOSURES
			add_action('edit_comment','podPress_comment_do_enclose');	 // CHECKS AN UPDATED COMMENT FOR ENCLOSURES
		}
	}
?>
